#include "a.h"

/** a bit of tuning for fast smartwrapper representation allocation **/

ARep *ARep::aRepStore = 0;

ARep *ARep::alloc()
{
	ARep *rep = aRepStore;
	if(rep)
		aRepStore = aRepStore->nextFree;
	else
		rep = new ARep;
	return rep;
}

/** test program **/

int main()
{
	A a;      // - this is the line with the smartwrapper
	// A_impl a; - uncomment this line to compare with plain "impl" performance

	cout << "+ assignment * 10 000 000\n";
	for(int i = 0;i<10000000;i++) {
		set5(a);
	}
	cout << "- assignment\n";
	cout << a.value() << endl;

	return 0;
}
